# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "pbt"
version = "0.4.0"
authors = ["Will Sturgeon <willstrgn@gmail.com>"]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Property-based testing with `derive` macros, aware of mutual induction & instantiability."
readme = "README.md"
keywords = [
    "property",
    "proptest",
    "arbitrary",
    "fuzz",
    "test",
]
categories = [
    "algorithms",
    "data-structures",
    "development-tools::testing",
    "mathematics",
    "security",
]
license = "MIT OR Apache-2.0"
repository = "https://github.com/wrsturgeon/pbt"

[features]
malachite = ["dep:malachite"]
num-bigint = ["dep:num-bigint"]

[lib]
name = "pbt"
path = "src/lib.rs"

[dependencies.ahash]
version = "~0.8"

[dependencies.malachite]
version = "~0.9"
optional = true

[dependencies.num-bigint]
version = "~0.4"
optional = true

[dependencies.papaya]
version = "~0.2"

[dependencies.pbt-macros]
version = "0.4.0"

[dependencies.pretty_assertions]
version = "~1.4"

[dependencies.wyrand]
version = "~0.4"

[lints.clippy]
blanket_clippy_restriction_lints = "allow"
field_scoped_visibility_modifiers = "allow"
from_iter_instead_of_collect = "allow"
implicit_return = "allow"
inline_always = "allow"
iter_over_hash_type = "allow"
map_err_ignore = "allow"
min_ident_chars = "allow"
mod_module_files = "allow"
needless_borrowed_reference = "allow"
pointer_format = "allow"
pub_use = "allow"
pub_with_shorthand = "allow"
question_mark_used = "allow"
ref_patterns = "allow"
semicolon_if_nothing_returned = "allow"
semicolon_outside_block = "allow"
separated_literal_suffix = "allow"
shadow_reuse = "allow"
shadow_same = "allow"
shadow_unrelated = "allow"
single_call_fn = "allow"
single_char_lifetime_names = "allow"
std_instead_of_alloc = "allow"
type_complexity = "allow"
used_underscore_items = "allow"
wildcard-enum-match-arm = "allow"

[lints.clippy.cargo]
level = "deny"
priority = -1

[lints.clippy.complexity]
level = "deny"
priority = -1

[lints.clippy.correctness]
level = "deny"
priority = -1

[lints.clippy.pedantic]
level = "deny"
priority = -1

[lints.clippy.perf]
level = "deny"
priority = -1

[lints.clippy.restriction]
level = "deny"
priority = -1

[lints.clippy.style]
level = "deny"
priority = -1

[lints.clippy.suspicious]
level = "deny"
priority = -1
